% Type inference system (designed by M. Bruynooghe and J. Gallagher)
% Version 1.3 created by jpg on 08/08/2006
% (c) Roskilde University
 
:- module(canonical, [canonical/1, 
			    canonical_each/1,
			    melt/2, 
			    melteach/2,
			    variable/1]).

canonical(T) :-
	numbervars(T,0,_).
	
canonical_each([]).
canonical_each([X|Xs]) :-
	canonical(X),
	canonical_each(Xs).
	

melt(X,Y) :-
	melt1(X,Y,_Assoclist),
	!.

melt1(X,Y,S) :-
	variable(X),
	!,
	assoc(X,Y,S).
melt1(X,X,_) :-
	atomic(X),
	!.
melt1(X,Y,S) :-
	functor(X,F,N),
	functor(Y,F,N),
	meltargs(1,N,X,Y,S).

meltargs(I,N,_,_,_) :-
	I > N,
	!.
meltargs(I,N,X,Y,S) :-
	arg(I,X,Xi),
	melt1(Xi,Yi,S),
	arg(I,Y,Yi),
	I1 is I+1,
	meltargs(I1,N,X,Y,S).


assoc(X,Y,[assoc(X,Y)|_]) :-
	!.
assoc(X,Y,[_|S]) :-
	assoc(X,Y,S).

variable('$VAR'(X)) :-
	integer(X).	

melteach([],[]).
melteach([X|Xs],[Y|Ys]) :-
	melt(X,Y),
	melteach(Xs,Ys).